
var loaderUtils = require("loader-utils");

// using: regex, capture groups, and capture group variables.
var templateIdRegex = /@NarikTemplateUi\s*\((\s*['"`](.*?)['"`]\s*([)}]))/gm;
var applyBaseUrlRegex = /applyBaseTemplate\(cls,\s*(\s*['"`](.*?)['"`]\s*([)}]))/gm;
//var templateIdRegex = /@NarikTemplateUi\s*(\s*['"`](.*?)['"`]\s*([,}]))\)/gm;
var stringRegex = /(['`"])((?:[^\\]\\\1|.)*?)\1/g;

function replaceStringsWithRequires(string, config) {
  return string.replace(stringRegex, function (match, quote, url) {
    if (url.charAt(0) !== ".") {
      url = "./" + url;
    }
    ulr = replaceFromConfig(url, config);
    return "require('" + url + "')";
  });
}

function replaceFromConfig(url, config) {
  Object.keys(config).forEach(function (key) {
    if (url === key)
      return config[key];
  });
}

module.exports = function (source, sourcemap) {

  var config = {};
  var query = loaderUtils.parseQuery(this.query);
  var templateDecorator = '@NarikTemplateUi';
  var applyBaseItemFunc = 'applyBaseTemplate(cls,';

  if (this.options != null) {
    Object.assign(config, this.options['narikWebpackLoader']);
  }

  Object.assign(config, query);

  // Not cacheable during unit tests;
  this.cacheable && this.cacheable();

  var newSource = source.replace(templateIdRegex, function (match, url) {
    return templateDecorator + "(" + replaceStringsWithRequires(url, config);
  });

  newSource = newSource.replace(applyBaseUrlRegex, function (match, url) {
    return applyBaseItemFunc + replaceStringsWithRequires(url, config);
  });

  // Support for tests
  if (this.callback) {
    this.callback(null, newSource, sourcemap)
  } else {
    return newSource;
  }
};
